#!/bin/bash
### Expresso Livre - CELEPAR ###
# @Author : Alexandre Correia (alexandrecorreia@celepar.pr.gov.br)
# @Date   : 17/06/2009
# @Description : Script para assinar applets(Java) e seus plugins.
#########################################################################
#
# IMPORTANTE : CONFIGURE ESTE SCRIPT, CONFORME SUA NECESSIDADE
#
#########################################################################

#########################################################################
# Configure sua workspace #
#########################################################################
WORKSPACE_DIST="<informe_aqui_sua_workspace>/java_source/dist"
WORKSPACE_BUILD="<informe_aqui_sua_workspace>/java_source/build"

#########################################################################
# Assinando Applet - Dados da Assinatura #
#########################################################################
CN="Expresso Livre - Celepar"
OU="Diser"
_O="CELEPAR"
_C="BR"
DAYS="1460"
PASSWORD_STORE="celepar"
ALIAS_NAME="celepar"
KEY_STORE="jarsigned/celeparIM"

#########################################################################
# Verifica a escolha do usuario #
#########################################################################
choice_user()
{
	case $1 in
		s|S) 
			jarsing_java_applets	
		;;

		n|N)
			echo "Nao sera assinado os .jar"
		;;

		*)
			echo "Opcao invalida !"
		;;
	esac
}

#########################################################################
# Assina os .jar gerados #
#########################################################################
jarsing_java_applets()
{
	APPLET=$WORKSPACE_DIST"/applet/applet.jar"
	PLUGINS=$WORKSPACE_DIST"/applet/plugins"

	if [ -e $APPLET ]
	then
		if [ -e $KEY_STORE ]
		then
			echo " Assinando applet...."
			jarsigner -keystore $KEY_STORE -storepass $PASSWORD_STORE $APPLET $ALIAS_NAME
		
			for i in $(ls $PLUGINS)
			do
				PLUGIN_FILE=$PLUGINS"/"$i
				echo "Assinando Plugin : " $i
				jarsigner -keystore $KEY_STORE -storepass $PASSWORD_STORE $PLUGIN_FILE $ALIAS_NAME
			done
		else
			echo "ERRO no KEY_STORE"
		fi
	fi
}

#########################################################################
# Verifica a existencia de um certificado
#########################################################################
if [ -a $KEY_STORE ]
then
	echo "Já existe uma chave criada."
	echo "Deseja assinar agora seus .jar? (S/N)"
	read YES_NO
	choice_user $YES_NO
else
	mkdir jarsigned
	keytool -genkey -dname "cn=$CN,ou=$OU,o=$_O,c=$_C" -alias $ALIAS_NAME -keystore $KEY_STORE -storepass $PASSWORD_STORE -validity $DAYS
	if [ -a $KEY_STORE ] 
	then
		echo "Chave Criada com sucesso!"
		echo "Deseja assinar agora seus .jar? (S/N)"
		read YES_NO
		choice_user $YES_NO
	else
		echo "Problemas na criacao da chave!"
	fi
fi
